#include <kpathsea/config.h>

extern char *filename;

#define SYS_ERR strerror(errno)

#define AND ,

#define FAIL(S) do {                                \
    fprintf (stderr, "\n! Error: %s", program_invocation_name);\
    if (filename != NULL)                           \
        fprintf(stderr, " (file %s)", filename);    \
    fprintf(stderr, ":\n ==> ");                    \
    fprintf(stderr, S);                             \
    fprintf(stderr, "\n");                          \
    exit(-1);                                       \
} while (0)

#define WARN(S) do {                                \
    fprintf (stderr, "\nWarning: %s", program_invocation_name);\
    if (filename != NULL)                           \
        fprintf(stderr, " (file %s)", filename);    \
    fprintf(stderr, ":\n ==> ");                    \
    fprintf(stderr, S);                             \
    fprintf(stderr, "\n");                          \
} while (0)

extern char *getstr(char *, int);
extern size_t xfwrite(void *, size_t, size_t, FILE *);
extern int xfflush(FILE *);
extern char *getstr(char *, int);

#define MALLOC(t,s)     (t *)(xmalloc((s)*sizeof(t)))

#define EXTERN extern
#include "pdftexd.h"

#define pdfbuf         dvibuf
#define pdfbufsize     dvibufsize
#define pdffile        dvifile
#define pdfgone        dvigone

#define nozip       0
#define zipwritting 1
#define zipfinish   2
                                
#define pdfout(c) do {        \
    pdfbuf[pdfptr++] = c;     \
    if (pdfptr == pdfbufsize) \
        pdfflush();           \
} while (0)

#define flushstring() do {    \
	strptr--;                 \
	poolptr=strstart[strptr]; \
} while (0)
